/***********************************************************************
 ***        Beispielprogramm fr die PC-Steckkarte ZIB 1155          ***
 ***********************************************************************/

#include <stdio.h>                       /* Prototypen fr Ein-Ausgabe */
#include <stdlib.h>
#include <conio.h>
#include <dos.h>

void clear_screen(void);
void write_position(int x, int y, char *text, int attr);
void main_menu(void);
void show_menu(void);
void show(void);
void output_menu(void);
void input_menu(void);
int  change_bits(int a);
int  key,i,a;
int  a1=0,a2=0;
int  address=0x100;

/************************************************************************
 ***                        Hauptprogramm                             ***
 ************************************************************************/

int main(void)                          /* Rckgabewert des Programms : */
{
  for (i=0;i<=3;i++)  		        /* Initialisierung der Zhler   */
    {
      outportb(address+8*i+5,0);
      for (a=1;a<=4;a++)
	outportb(address+8*i+a,0);
    }
  clear_screen();                       /* Bildschirm lschen           */
  _setcursortype(_NOCURSOR);            /* Cursor aus                   */
  main_menu();                          /* Hauptmenu darstellen         */
  key=0;                                /* Variable fr Taste initialisieren */
  do                                    /* in Schleife verharren        */
    {                                   /* bis Taste F1-3 oder F10 gedrckt */
      i=kbhit();
      if (i==-1)                        /* Ist Taste gedrckt ?         */
	{                               /* Wenn ja, dann                */
	  key=getch();                  /* ASCII-Wert lesen             */
	  if (key==0)
	    key=getch();                /* Scan-Code holen              */
	  switch (key)
	    {
	      case 59:{                 /* Bei F1 : Zhler Anzeigen     */
			show();
			main_menu();
			key=0;
			break;
		      }
	      case 60:{                 /* Bei F2 : Digitale Ausgnge   */
			output_menu();
			main_menu();
			key=0;
			break;
		      }
	      case 61:{                 /* Bei F3 : Digitale Eingnge   */
			input_menu();
			main_menu();
			key=0;
			break;
		      }
	    }
	}
    }
  while (key!=68);                      /* Wenn F10, dann ende          */
  clear_screen();
  _setcursortype(_NORMALCURSOR);        /* Standardcursor an            */
  textattr(0x07);
  clrscr();
  return 0;
}

/************************************************************************
 ***                Menusteuerung                                     ***
 ************************************************************************/
void main_menu(void)
{
  char text1[]=" F1  = Zhler anzeigen   ";
  char text2[]=" F2  = Digitale Ausgnge ";
  char text3[]=" F3  = Digitale Eingnge ";
  char text4[]=" F10 = ENDE              ";
  int x=26;
  int y=10;

  clear_screen();
  write_position(x,y,text1,1);
  write_position(x,y+2,text2,1);
  write_position(x,y+4,text3,1);
  write_position(x,y+6,text4,1);
}

/************************************************************************/

void output_menu(void)
{
  char text1[]="        Digitale Ausgnge         ";
  char text2[]="      Bit         7 6 5 4 3 2 1 0 ";
  char text3[]="F1 :  Port  A1 =                  ";
  char text4[]="F2 :  Port  A2 =                  ";
  char text5[]="        Ende = F10                ";
  int x=22;
  int y=10;
  int xx;

  clear_screen();                       /* Bildschirmdarstellung        */
  write_position(x,y-2,text1,1);
  write_position(x,y,text2,1);
  write_position(x,y+1,text3,1);
  write_position(x,y+2,text4,1);
  write_position(x,y+4,text5,1);
  do                                    /* in Schleife verharren        */
    {                                   /* bis Taste F10 gedrckt       */
      for (i=7;i>=0;i--)
	{
	xx=128 >> i;
	if ((a1 & xx)==xx)
	    write_position(x+18+2*i,y+1,"1",1);
	  else
	    write_position(x+18+2*i,y+1,"0",1);
	if ((a2 & xx)==xx)
	    write_position(x+18+2*i,y+2,"1",1);
	  else
	    write_position(x+18+2*i,y+2,"0",1);
	}
      i=kbhit();
      if (i==-1)                        /* Ist Taste gedrckt ?         */
	{                               /* Wenn ja, dann                */
	  key=getch();                  /* ASCII-Wert lesen             */
	  if (key==0)
	    {
	      key=getch();              /* Scan-Code holen              */
	      switch (key)
		{                       /* Ausgabe nur bei Tastendruck  */
		  case 59:{             /* Bei F1 : Ausgang 1           */
			    a1=change_bits(a1);
			    outportb(address+6,a1);
			    break;
			  }
		  case 60:{             /* Bei F2 : Ausgang 2            */
			    a2=change_bits(a2);
			    outportb(address+7,a2);
			    break;
			  }
		}
	    }
	}
    }
  while (key!=68);                /* Wenn F10, dann ende          */
  clear_screen();

}

/************************************************************************/

int change_bits(int a)
{
  char text1[]="        Bits invertieren         ";
  char text2[]="  Bit    7  6  5  4  3  2  1  0  ";
  char text3[]=" Drcken Sie entsprechende Zahl  ";
  char text4[]="        Ende = F10               ";
  char ltext[]="                                 ";
  int x=22;
  int y=20;
  int i;
  int n;

  write_position(x,y-3,text1,1);
  write_position(x,y-1,text2,1);
  write_position(x,y,ltext,1);
  write_position(x,y+2,text3,1);
  write_position(x,y+3,text4,1);

  do
    {
      for (n=0;n<=7;n++)
	{
	  i=128 >> n;
	  if ((a & i)==i)
	      write_position(x+9+3*n,y,"1",1);
	    else
	      write_position(x+9+3*n,y,"0",1);
	}
      i=kbhit();
      if (i==-1)                        /* Ist Taste gedrckt ?         */
	{                               /* Wenn ja, dann                */
	  key=getch();                  /* ASCII-Wert lesen             */
	  if ((key>='0') && (key<='7')) /* wenn Taste 0-7 dann          */
	    a=(a ^ (1 << (key-'0')));   /* entsprechendes Bit invertieren */
	  if (key==0)
	    {
	      key=getch();              /* Scan-Code holen              */
	    }
	}
    }
  while (key!=68);                      /* Ende bei F10                 */
  key=0;
  write_position(x,y-3,ltext,0);        /* unteren Bildschirmteil lschen */
  write_position(x,y-1,ltext,0);
  write_position(x,y,ltext,0);
  write_position(x,y+2,ltext,0);
  write_position(x,y+3,ltext,0);
  return a;
}

/************************************************************************/

void input_menu(void)
{
  char text1[]="         Digitale Eingnge        ";
  char text2[]=" Bit       7  6  5  4  3  2  1  0 ";
  char text3[]=" Port E1 =                        ";
  char text4[]=" Port E2 =                        ";
  char text5[]="         Ende = F10               ";
  int x=22;
  int y=10;
  int e1,e2,i;

  clear_screen();                       /* Bildschirmdarstellung        */
  write_position(x,y,text1,1);
  write_position(x,y+2,text2,1);
  write_position(x,y+3,text3,1);
  write_position(x,y+4,text4,1);
  write_position(x,y+6,text5,1);

  do
    {
      e1=inportb(address+6);            /* Einlesen Port 1              */
      e2=inportb(address+7);            /* Einlesen Port 2              */
      for (i=7;i>=0;i--)
	{                               /* Ergebnis auf Bildschirm      */
	  if ((e1 & (128 >> i))==(128 >> i))
	    write_position(x+11+i*3,y+3,"0",1);
	   else
	    write_position(x+11+i*3,y+3,"1",1);
	  if ((e2 & (128 >> i))==(128 >> i))
	    write_position(x+11+i*3,y+4,"0",1);
	   else
	    write_position(x+11+i*3,y+4,"1",1);
	}
      i=kbhit();
      if (i==-1)                        /* Ist Taste gedrckt ?         */
	{                               /* Wenn ja, dann                */
	  key=getch();                  /* ASCII-Wert lesen             */
	  if (key==0)
	      key=getch();              /* Scan-Code holen              */
	}
    }
  while (key!=68);
  key=0;
}

/************************************************************************/

void show(void)
{
  char text1[]=" Anzeige der Zhlerstnde ";
  char text2[]=" Zhler 1 :               ";
  char text3[]=" Zhler 2 :               ";
  char text4[]=" Zhler 3 :               ";
  char text5[]=" Zhler 4 :               ";
  char text6[]="      ENDE mit F10        ";
  int  x=25;
  int  y=10;
  int  i,a=0;
  union {
	  signed long wert;
	  struct { unsigned char byte1,byte2,byte3,byte4; } st;
	} un;

  clear_screen();
  write_position(x,y,text1,1);
  write_position(x,y+2,text2,1);
  write_position(x,y+3,text3,1);
  write_position(x,y+4,text4,1);
  write_position(x,y+5,text5,1);
  write_position(x,y+7,text6,1);
  do
    {
      a++;
      if (a>3)
	a=0;
      outportb(address+a*8,0);          /* Einlesen der Zhlerstnde in */
      un.st.byte1=inportb(address+a*8+1);  /* die UNION, dadurch entfllt */
      un.st.byte2=inportb(address+a*8+2);  /* die Umrechnung !          */
      un.st.byte3=inportb(address+a*8+3);
      un.st.byte4=inportb(address+a*8+4);
      write_position(x+15,y+2+a,"",1);
      printf("%ld     ",un.wert);
      write_position(x+19,y+2+a,"",1);
      i=kbhit();
      if (i==-1)                        /* Ist Taste gedrckt ?         */
	{                               /* Wenn ja, dann                */
	  key=getch();                  /* ASCII-Wert lesen             */
	  if (key==0)
	    {
	      key=getch();              /* Scan-Code holen              */
	    }
	}
    }
  while (key!=68);                      /* Wenn F10, dann ende          */

}

/************************************************************************
 ***                Unterprogramme zur Bildschirmsteuerung            ***
 ************************************************************************/

void clear_screen(void)
{
  /* Diese Funktion dient zum lschen des Bildschirmes, sowie dessen
     Einstellung. Der Hintergrund wird auf die Farbe Blau eingestellt.
     Es wird des weiteren ein Fenster mit der Firmenadresse dargestellt.  */

  char rahm1[]="ͻ";
  char rahm2[]="                                                         ";
  char rahm3[]="ͼ";
  char text1[]=" ERMA-Electronic GmbH, Max-Eyth-Str. 8, 7717 Immendingen ";
  char text2[]="      Tel. 07462/7381               Fax 07462/7554       ";
  char text3[]="";

  textbackground(BLUE);                 /* Hintergrundfarbe schwarz     */
  textcolor(CYAN);                      /* Vordergrundfarbe hellgrau    */
  clrscr();                             /* Bildschirm lschen           */

  /* Erzeugen eines Fensters */
  gotoxy(12,2);
  textattr(0x7F);
  cprintf(rahm1);
  gotoxy(12,3);
  cprintf(rahm2);
  gotoxy(12,4);
  cprintf(rahm2);
  gotoxy(12,5);
  cprintf(rahm3);
  /* Erzeugen des Fenstertextes */
  textattr(0x70);
  gotoxy(13,3);
  cprintf(text1);
  gotoxy(13,4);
  cprintf(text2);
  /* Erzeugen des Fensterschattens */
  gotoxy(13,6);
  cprintf(text3);
  gotoxy(71,3);
  cprintf("");
  gotoxy(71,4);
  cprintf("");
  gotoxy(71,5);
  cprintf("");
  textattr(0x03);
}


/************************************************************************/

void write_position(int x,int y,char *text,int attr)
{
  if (attr==0)
    textattr(0x10);
  if (attr==1)
    textattr(0x3E);
  gotoxy(x,y);
  cprintf(text);

}
