program ZIB1155;

(**************************************
 *  Zhlerprfprogramm fr ZIB 1155   *
 **************************************)

USES Graph,Crt;
TYPE  int_array = array [1..4] of integer;
CONST Ende     : boolean = FALSE;
      dauernd  : boolean = TRUE;
      adresse  : int_array = ($100,$108,$110,$118);
VAR   Wert     : int_array;
      A,B,C,D  : integer;
      i,n      : integer;
      Zurueck  : boolean;
      Reset    : boolean;
      remkey   : integer;
      ch,VorCh : array [1..4] of array [1..7] of string;

procedure Initialisieren;
begin
     for i:=1 to 4 do
         for n:=1 to 5 do
             Port[adresse[i]+n]:=0;
end;

procedure Einlesen;
begin
     for i:=1 to 4 do begin
         Port[adresse[i]]:=0;
         A:=Port[adresse[i]+1];
         B:=Port[adresse[i]+2];
         C:=Port[adresse[i]+3];
         D:=Port[adresse[i]+4];
         delay(1);
         if C > 250 then  C:=(255-C)*(-1);
         Wert[i]:=(A+256*B)+65536*C;
     end;
end;

procedure Ausgabe;
var  WertStr  : array [1..4] of string;
     Len      : byte;
begin
     for i:=1 to 4 do
         str(Wert[i],WertStr[i]);
     (* Zerlegen der Strings in einzelne Zeichen *)
     for i:=1 to 4 do begin
         Len:=Length(WertStr[i]);
         if Len<7 then
            for n:=1 to (7-Len) do
                WertStr[i]:=' '+WertStr[i];
         for n:=1 to 7 do
             ch[i] [n] :=Copy(WertStr[i],n,1);
     end;
     (* Prfen, ob sich einzelne Zeichen gendert haben und Neuausgabe bei
        nderung: *)
     SetTextStyle(SansSerifFont,HorizDir,7);
     SetTextJustify(RightText,CenterText);
     SetColor(14);
     for n:=1 to 7 do begin
         if ch[1] [n] <> VorCh[1] [n] then begin
            SetViewPort((GetMaxX div 14)*(n-1)+6,28,(GetMaxX div 14)*n-6,126,true);
            ClearViewPort;
            OutTextXY(40,40,ch[1] [n]);
            VorCh[1] [n]:=ch[1] [n];
         end;
         if ch[2] [n] <> VorCh[2] [n] then begin
            SetViewPort(GetMaxX-(50*(8-n))-6,28,GetMaxX-(50*(7-n))-6,126,true);
            ClearViewPort;
            OutTextXY(40,40,ch[2] [n]);
            VorCh[2] [n]:=ch[2] [n];
         end;
         if ch[3] [n] <> VorCh[3] [n] then begin
            SetViewPort((GetMaxX div 14)*(n-1)+6,131,(GetMaxX div 14)*n-6,229,true);
            ClearViewPort;
            OutTextXY(40,40,ch[3] [n]);
            VorCh[3] [n]:=ch[3] [n];
         end;
         if ch[4] [n] <> VorCh[4] [n] then begin
            SetViewPort(GetMaxX-(50*(8-n))-6,131,GetMaxX-(50*(7-n))-6,229,true);
            ClearViewPort;
            OutTextXY(40,40,ch[4] [n]);
            VorCh[4] [n]:=ch[4] [n];
         end;
     end;
     SetColor(15);
end;

procedure Bild;
var  GraphMode,GraphDriver : integer;
     VorDauernd            : boolean;
begin
     GraphDriver:=Detect;
     InitGraph(GraphDriver,GraphMode,'');
     SetBkColor(1);
     Rectangle(0,0,GetMaxX,GetMaxY);
     MoveTo(0,24); LineTo(GetMaxX,24);
     Rectangle(5,27,GetMaxX div 2-3,127);
     Rectangle(5,130,GetMaxX div 2-3,230);
     Rectangle(GetMaxX div 2+2,27,GetMaxX-5,127);
     Rectangle(GetMaxX div 2+2,130,GetMaxX-5,230);
     MoveTo(0,233); LineTo(GetMaxX,233);
     SetTextStyle(SansSerifFont,HorizDir,2);
     SetTextJustify(CenterText,CenterText);
     OutTextXY(GetMaxX div 2,8,'Zhlerprfprogramm fr ZIB 1155');
     SetViewPort(1,234,GetMaxX div 2,GetMaxY-1,true);
     ClearViewPort;
     SetViewPort(0,0,GetMaxX,GetMaxY,true);
     SetTextStyle(DefaultFont,HorizDir,1);
     SetTextJustify(LeftText,CenterText);
     OutTextXY(20,290,'RETURN    : Messung starten');
     OutTextXY(20,310,'ESC       : Programm beenden');
     OutTextXY(20,330,'Leertaste : Einlesemodus umschalten');
     SetTextStyle(SansSerifFont,HorizDir,1);
     SetColor(12);
     OutTextXY(GetMaxX div 7,250,'HAUPTMENUE');
     SetColor(15);
     OutTextXY(3*GetMaxX div 4-20,305,'Einlesemodus: ');
     repeat
           if VorDauernd<>dauernd then begin
              SetViewPort(GetMaxX-60,300,GetMaxX-30,320,true);
              ClearViewPort;
              Vordauernd:=dauernd;
           end;
           if dauernd=TRUE then
              OutTextXY(10,5,'D')
           else
              OutTextXY(10,5,'M');
           if keypressed then begin
              remkey:=ord(readkey);
              if remkey=32 then
                 dauernd:=not dauernd;
           end;
     until (remkey=13) or (remkey=27);
end;

BEGIN
     remkey:=0;
     repeat
           Bild;
           Initialisieren;
           for i:=1 to 4 do
               for n:=1 to 7 do
                   VorCh[i] [n]:=' ';
           if remkey<>27 then begin
              SetViewPort(1,234,GetMaxX div 2,GetMaxY-1,true);
              ClearViewPort;
              SetViewPort(0,0,GetMaxX,GetMaxY,true);
              SetColor(10);
              OutTextXY(GetMaxX div 7,250,'MENUE MESSEN');
              SetColor(15);
              SetTextStyle(DefaultFont,HorizDir,1);
              OutTextXY(20,290,'H         : Zurueck zum Hauptmenue');
              OutTextXY(20,310,'R         : Software - Reset');
              OutTextXY(20,330,'ESC       : Ende des Programms');
              remkey:=0;
              Zurueck:=FALSE;
              repeat
                 Reset:=FALSE;
                 Einlesen;
                 Ausgabe;
                 if not dauernd then begin
                    SetViewPort(0,0,GetMaxX,GetMaxY,true);
                    SetTextStyle(DefaultFont,HorizDir,1);
                    SetTextJustify(LeftText,CenterText);
                    OutTextXY(20,270,'Leertaste : noch eine Messung');
                    case ord(readkey) of
                         27 : Ende:=TRUE;
                         72 : Zurueck:=TRUE;
                         104: Zurueck:=TRUE;
                         82 : Reset:=TRUE;
                         114: Reset:=TRUE;
                    end;
                 end else begin
                    if keypressed then begin
                       remkey:=ord(readkey);
                       case remkey of
                            27 : Ende:=TRUE;
                            72 : Zurueck:=TRUE;
                            104: Zurueck:=TRUE;
                            82 : Reset:=TRUE;
                            114: Reset:=TRUE;
                       end;
                    end;
                 end;
                 if Reset then
                    Initialisieren;
              until Ende or Zurueck;
           end else Ende:=TRUE;
     until Ende;
  RestoreCrtMode;
END.