Attribute VB_Name = "Module3"
Rem ************************************************
Rem *** Diese Funktionen dienen der Umrechnung   ***
Rem *** der von der Karte gelieferten Bytes in   ***
Rem *** die entsprechenden Variablen und zur     ***
Rem *** Initialisierung der Zhler in den        ***
Rem *** gewnschten Modi                         ***
Rem ************************************************

Rem *** Definition der Zhlermodi ***
Private Const Zaehler1Mode = Einmal_32Bit Or VierfachZaehlungA Or VierfachZaehlungB Or HystereseA
Private Const Zaehler2Mode = Einmal_32Bit Or VierfachZaehlungA Or VierfachZaehlungB Or HystereseA
Private Const Zaehler3Mode = Einmal_32Bit Or VierfachZaehlungA Or VierfachZaehlungB Or HystereseA
Private Const Zaehler4Mode = Einmal_32Bit Or VierfachZaehlungA Or VierfachZaehlungB Or HystereseA
Rem *** Definition der Zhler ***
Public Const Zaehler1 = 1
Public Const Zaehler2 = 2
Public Const Zaehler3 = 3
Public Const Zaehler4 = 4
Rem *** Definition der Ports ***
Public Const PortInLow = 1
Public Const PortInHigh = 2
Public Const PortOutLow = 1
Public Const PortOutHigh = 2
Rem *** Definition der Portzustnde ***
Public Const PortHigh = 1
Public Const PortLow = 0

Rem ************************************************
Rem *** Initialisierung der Zhler               ***
Rem ************************************************

Sub InitZaehler()
  Rem *** Zhlermodes setzen ***
  Call SetZaehlerMode(Zaehler1, Zaehler1Mode)
  Call SetZaehlerMode(Zaehler2, Zaehler2Mode)
  Call SetZaehlerMode(Zaehler3, Zaehler3Mode)
  Call SetZaehlerMode(Zaehler4, Zaehler4Mode)
  Rem *** alle Zhler werden automatisch zurckgesetzt ***
End Sub

Rem ************************************************
Rem *** Diese Funktion dient dazu die Bytes der  ***
Rem *** Eingangsports auf die Variablen E1 bis   ***
Rem *** E16 zu verteilen                         ***
Rem ************************************************

Sub GetEingangsPorts()
  Rem *** Zwischenspeicher fr Eingangsports ***
  Dim P1, P2 As Byte
  
  Rem *** Ports einlesen ***
  P1 = GetPort(PortInLow)
  P2 = GetPort(PortInHigh)
  Rem *** Portwerte auf Variablen vereinzeln
  Rem *** Port 1 (E1 bis E8)
  If (P1 And &H1) = &H1 Then E1 = PortHigh Else E1 = PortLow
  If (P1 And &H2) = &H2 Then E2 = PortHigh Else E2 = PortLow
  If (P1 And &H4) = &H4 Then E3 = PortHigh Else E3 = PortLow
  If (P1 And &H8) = &H8 Then E4 = PortHigh Else E4 = PortLow
  If (P1 And &H10) = &H10 Then E5 = PortHigh Else E5 = PortLow
  If (P1 And &H20) = &H20 Then E6 = PortHigh Else E6 = PortLow
  If (P1 And &H40) = &H40 Then E7 = PortHigh Else E7 = PortLow
  If (P1 And &H80) = &H80 Then E8 = PortHigh Else E8 = PortLow
  Rem *** Port 2 (E9 bis E16)
  If (P2 And &H1) = &H1 Then E9 = PortHigh Else E9 = PortLow
  If (P2 And &H2) = &H2 Then E10 = PortHigh Else E10 = PortLow
  If (P2 And &H4) = &H4 Then E11 = PortHigh Else E11 = PortLow
  If (P2 And &H8) = &H8 Then E12 = PortHigh Else E12 = PortLow
  If (P2 And &H10) = &H10 Then E13 = PortHigh Else E13 = PortLow
  If (P2 And &H20) = &H20 Then E14 = PortHigh Else E14 = PortLow
  If (P2 And &H40) = &H40 Then E15 = PortHigh Else E15 = PortLow
  If (P2 And &H80) = &H80 Then E16 = PortHigh Else E16 = PortLow
End Sub

Rem ************************************************
Rem *** Diese Funktion dient dazu die Variablen  ***
Rem *** fr die Zhler zu aktualisieren          ***
Rem ************************************************

Sub UpdateZaehler()
  Z1 = GetZaehler(Zaehler1)
  Z2 = GetZaehler(Zaehler2)
  Z3 = GetZaehler(Zaehler3)
  Z4 = GetZaehler(Zaehler4)
End Sub

Rem ************************************************
Rem *** Diese Funktion kombiniert die Variablen  ***
Rem *** zu 2 Ausgangsbytes, die zur Karte        ***
Rem *** geschrieben werden                       ***
Rem ************************************************

Sub UpdatePorts()
  Dim BL, BH As Byte
  Rem *** erstes Byte zusammensetzen ***
  BL = 0
  If A1 Then BL = BL Or &H1
  If A2 Then BL = BL Or &H2
  If A3 Then BL = BL Or &H4
  If A4 Then BL = BL Or &H8
  If A5 Then BL = BL Or &H10
  If A6 Then BL = BL Or &H20
  If A7 Then BL = BL Or &H40
  If A8 Then BL = BL Or &H80
  Rem *** zweites Byte zusammensetzen ***
  BH = 0
  If A9 Then BH = BH Or &H1
  If A10 Then BH = BH Or &H2
  If A11 Then BH = BH Or &H4
  If A12 Then BH = BH Or &H8
  If A13 Then BH = BH Or &H10
  If A14 Then BH = BH Or &H20
  If A15 Then BH = BH Or &H40
  If A16 Then BH = BH Or &H80
  Rem *** Beide Bytes ausgeben ***
  Call SetPort(PortOutLow, (BL))
  Call SetPort(PortOutHigh, (BH))
End Sub
