REM *******************************************************
REM ***        Programm zum Testen der PC-Karte         ***
REM ***                   TTY 1241                      ***
REM *******************************************************

$COM1 1024    ' Speicherplatz fuer Schnittstelle
CLS
REM ==== Bildschirm initialisieren ====
GOSUB INITS

ANFANG:
GOSUB CLAERS
FEHLER=0
ON ERROR GOTO FEHLERBEHANDLUNG
GOSUB MENUW
MENU:
E$=INPUT$(1)
IF E$="0" THEN
  CLS
  END
END IF
IF ((E$="1") OR (E$="2") OR (E$="3") OR (E$="4") OR (E$="5") OR (E$="6")) THEN
    IF E$="1" THEN OPEN "COM1:300,N,8,2" AS #1 LEN=1
    IF E$="2" THEN OPEN "COM1:600,N,8,2" AS #1 LEN=1
    IF E$="3" THEN OPEN "COM1:1200,N,8,2" AS #1 LEN=1
    IF E$="4" THEN OPEN "COM1:2400,N,8,2" AS #1 LEN=1
    IF E$="5" THEN OPEN "COM1:4800,N,8,2" AS #1 LEN=1
    IF E$="6" THEN OPEN "COM1:9600,N,8,2" AS #1 LEN=1
  ELSE
    GOTO MENU
END IF
GOSUB CLAERS
GOSUB TESTW
ON COM(1) GOSUB LESEN
COM(1) ON
REM ==== TESTEN ALLER DRUCKBAREN ZEICHEN ====
FOR X=33 TO 255
  ON COM(1) GOSUB LESEN
  TIMEOUT=0
  FLAG=0
  REM ==== ZEICHEN AUSGEBEN ====
  PRINT #1,CHR$(x)
  COM(1) ON
  REM ==== TIMEOUT NACH 3 SEKUNDEN ====
  ON TIMER(3) GOSUB ZEIT
  TIMER ON
  REM ==== WARTEN BIS ZEICHEN EINGELESEN ODER TIMEOUT ====
  WEITER:
  IF FLAG=0 THEN
      IF FEHLER=0 THEN GOTO WEITER
  END IF
  REM ==== TIMER AUS ====
  TIMER OFF
  REM ==== EINGABEN VON COM1 AUFHEBEN ====
  COM(1) STOP
  REM ==== WENN FEHLER DANN TEST ABBRECHEN ====
  IF FEHLER=1 THEN X=255
NEXT X
REM ==== TESTENDE, COM1 AUS UND SCHLIESSEN ====
COM(1) OFF
CLOSE #1
REM ==== TESTERGEBNIS AUSGEBEN ====
GOSUB CLAERS
GOSUB ERGEBNISW
REM ==== WARTEN AUF LEERZEICHEN VON TASTATUR ====
SCHLEIFE:
E$=INPUT$(1)
IF E$=" " THEN
  REM ==== AUF AUSGANGSSTELLUNG ====
  GOSUB INITS
  GOTO ANFANG
 ELSE
  GOTO SCHLEIFE
END IF
END

REM *******************************************************
REM ***               Unterprogramme                    ***
REM *******************************************************

REM ==== Unteren Teil vom Anfangsbildschirm loeschen ====
CLAERS:

  X$=""
  FOR X=1 TO 79
    X$=X$+CHR$(176)
  NEXT X
  LOCATE 8,1
  FOR X=1 TO 15
    PRINT X$;
  NEXT X

RETURN

REM ==== Anfangsbildschirm darstellen ====
INITS:

  LOCATE 1,1
  X$=""
  FOR X=1 TO 79
    X$=X$+CHR$(176)
  NEXT X
  FOR X=1 TO 23
    PRINT X$;
  NEXT X
  X$=""
  FOR X=1 TO 6
    X$=X$+CHR$(176)
  NEXT X
  LOCATE 2,1
  PRINT X$;"ͻ"
  PRINT X$;"  Programm zum Testen der PC-Karte          ERMA-Electronic     "
  PRINT X$;"            TTY 1241                        7717 Immendingen    "
  PRINT X$;"ͼ"

RETURN

REM ==== Testfenster darstellen ====
TESTW:

  LOCATE 10,25
  PRINT "Ŀ"
  LOCATE 11,25
  PRINT " Gesendetes Zeichen       "
  LOCATE 12,25
  PRINT ""
  LOCATE 13,25
  PRINT "Ŀ"
  LOCATE 14,25
  PRINT " Empfangenes Zeichen      "
  LOCATE 15,25
  PRINT ""

RETURN

REM ==== Ergebnis ausgeben ====
ERGEBNISW:

  LOCATE 10,20
  PRINT "ͻ"
  IF FEHLER=0 THEN
    LOCATE 11,20
    PRINT "        Karte ist in Ordnung !         "
   ELSE
    LOCATE 11,20
    PRINT "          Karte ist defekt   !         "
  END IF
  LOCATE 12,20
  PRINT "Ķ"
  LOCATE 13,20
  PRINT "        Weiter mit Leertaste           "
  LOCATE 14,20
  PRINT "ͼ"

RETURN

REM ==== Darstellen des Menu-Fensters ====
MENUW:

  LOCATE 10,25
  PRINT "ͻ"
  LOCATE 11,25
  PRINT "   1) Prfen mit 300  BAUD     "
  LOCATE 12,25
  PRINT "   2) Prfen mit 600  BAUD     "
  LOCATE 13,25
  PRINT "   3) Prfen mit 1200 BAUD     "
  LOCATE 14,25
  PRINT "   4) Prfen mit 2400 BAUD     "
  LOCATE 15,25
  PRINT "   5) Prfen mit 4800 BAUD     "
  LOCATE 16,25
  PRINT "   6) Prfen mit 9600 BAUD     "
  LOCATE 17,25
  PRINT "   0) PROGRAMMENDE             "
  LOCATE 18,25
  PRINT "Ķ"
  LOCATE 19,25
  PRINT "      Bitte whlen Sie         "
  LOCATE 20,25
  PRINT "ͼ"

RETURN

REM ==== Lesen der Eingangsdaten ====
LESEN:

  REM ==== EINGABEFLAG SETZEN UND TIMER AUSSTELLEN ====
  FLAG=1
  TIMER OFF
  DELAY 0.1
  REM ==== WENN KEIN FEHLER DANN EINLESEN ====
  IF FEHLER=0 THEN
      REM ==== ANZAHL ZEICHEN IM PUFFER ERMITTELN ====
      Q=1024-LOF(1)
      IF Q>=1 THEN
         REM ==== ZEICHEN EINLESEN ====
         A$=INPUT$(1,#1)
         REM ==== PUFFER ENTLEEREN ====
         IF Q>=1 THEN B$=INPUT$(1,#1)
      END IF
  END IF
  REM ==== COM1 AUSSCHALTEN ====
  COM(1) OFF
  REM ==== EMPFANGENES ZEICHEN AUSGEBEN ====
  LOCATE 11,51
  PRINT CHR$(x);
  REM ==== ERMITTELN OB FEHLER BEI UEBERTRAGUNG ====
  A$=LEFT$(A$,1)
  W=ASC(A$)
  LOCATE 14,51
  PRINT A$;
  IF W<>X THEN FEHLER=1

RETURN

REM ==== TIMEOUT ====
ZEIT:

  REM ==== BEI TIMEOUT FLAGS SETZEN ====
  TIMEOUT=1
  FEHLER=1

RETURN

REM ==== Fehlerbehandlung ====
FEHLERBEHANDLUNG:

  REM ==== FEHLERART ERMITTELN ====
  E=ERR
  REM ==== FEHLER AUF BILDSCHIRM DARSTELLEN ====
  GOSUB CLAERS
  IF ((E=24) OR (E=57) OR (E=69)) THEN
     REM ==== FEHLER DER SCHNITTSTELLE ====
     LOCATE 10,25
     PRINT "ͻ"
     LOCATE 11,25
     PRINT " TTY 1241-Karte nicht gefunden, "
     LOCATE 12,25
     PRINT " Bitte berprfen Sie die       "
     LOCATE 13,25
     PRINT " Stellung der DIP-Schalter, der "
     LOCATE 14,25
     PRINT " Jumper und des Teststeckers !  "
     LOCATE 15,25
     PRINT "Ķ"
     LOCATE 16,25
     PRINT "     Weiter mit Leertaste !     "
     LOCATE 17,25
     PRINT "ͼ"
   ELSE
     REM ==== UNVORHERSEHBARER FEHLER ====
     LOCATE 12,25
     PRINT "ͻ"
     LOCATE 13,25
     PRINT " Unvorhersehbarer Systemfehler !  "
     LOCATE 14,25
     PRINT "Ķ"
     LOCATE 15,25
     PRINT "      Weiter mit Leertaste !      "
     LOCATE 16,25
     PRINT "ͼ"
  END IF
  REM ==== COM1 SCHLIESSEN ====
  CLOSE #1
  REM ==== WARTEN AUF LEERTASTE DANN VON VORNE ====
  SCHLEIFEE:
  E$=INPUT$(1)
  IF E$=" " THEN RESUME ANFANG
  GOTO SCHLEIFEE


