/***************************************************************************
 ***        Programm zur Ansteuerung des Memodules                      ***
 ***                    MM-232.00                                        ***
 ***************************************************************************/

#include <stdio.h>           /* Prototypen fr Ein-Ausgabe */
#include <stdlib.h>
#include <conio.h>
#include <dos.h>

void clear_screen(void);
void write_position(int x, int y, char *text, int attr);
void main_menu(void);
void show_status(void);
void install(int baud);
char test_tty(void);
char test_irq(void);

void interrupt test_routine(void);
void interrupt (*oldint)(void);

int adr_tty=0x2E8;
int testirq=3;
char test[7][2];
char uart=0;
volatile char ready=0;
volatile unsigned char zeichen;

/************************************************************************
 ***                Hauptprogramm                                     ***
 ************************************************************************/

int main(void)
{
  int i,x,y;
  char key=0;


  clear_screen();                       /* Bildschirm lschen           */
  _setcursortype(_NOCURSOR);            /* Cursor aus                   */
  outportb(0x2F8+4,0);
  main_menu();                          /* Bildschirmdarstellung        */
  key=0;                                /* Variable fr Taste initialisieren */
  do                                    /* in Schleife verharren        */
    {                                   /* bis Taste F1-3 oder F10 gedrckt */
      i=kbhit();
      if (i==-1)                        /* Ist Taste gedrckt ?         */
	{                               /* Wenn ja, dann                */
	  key=getch();                  /* ASCII-Wert lesen             */
	  if (key==0)
	    {
	      key=getch();              /* Scan-Code holen              */
	      switch (key)
		{
		  case 59:
		    {                 /* Bei F1 : Testen       */
			for(x=0;x<7;x++)
			  for(y=0;y<2;y++)
			    test[x][y]=0;
			show_status();
			// Test im Pollingbetrieb
			install(75);
			test[0][0]=test_tty();
			show_status();
			install(300);
			test[1][0]=test_tty();
			show_status();
			install(1200);
			test[2][0]=test_tty();
			show_status();
			install(2400);
			test[3][0]=test_tty();
			show_status();
			install(4800);
			test[4][0]=test_tty();
			show_status();
			install(9600);
			test[5][0]=test_tty();
			show_status();
			install(19200);
			test[6][0]=test_tty();
			show_status();
			// Interrupttests
			install(75);
			test[0][1]=test_irq();
			show_status();
			install(300);
			test[1][1]=test_irq();
			show_status();
			install(1200);
			test[2][1]=test_irq();
			show_status();
			install(2400);
			test[3][1]=test_irq();
			show_status();
			install(4800);
			test[4][1]=test_irq();
			show_status();
			install(9600);
			test[5][1]=test_irq();
			show_status();
			install(19200);
			test[6][1]=test_irq();
			show_status();

			key=0;
			break;
		    }
		}
	    }
	}
    }
  while (key!=68);                      /* Wenn F10, dann ende          */

  textattr(0x07);
  clrscr();
  _setcursortype(_NORMALCURSOR);        /* Standardcursor an            */
  return 0;
}

/************************************************************************/

char test_irq(void)
{
  int x,y;
  long timeout;
  int oldmask;
  char INTNO,Mark;
  char erg=1;

  /* IRQ-Vektor setzen */
  if(testirq==3)
    {
      INTNO=0x0B;
      Mark=0xF7;
    }
  if(testirq==4)
    {
      INTNO=0x0C;
      Mark=0xEF;
    }
  oldint=getvect(INTNO);
  setvect(INTNO,test_routine);
  oldmask=inportb(0x21);
  outportb(0x21,oldmask & Mark);
  outportb(0x20,0x20);
  outportb(adr_tty+1,1);

  if(uart!=0)
    {
    while((inportb(adr_tty+5) & 1)==1)inportb(adr_tty);
    ready=0;
    for(x=32;x<256;x++)
      {
	timeout=0;
	while(((inportb(adr_tty+5) & 1)!=0) && (timeout<100000L)){inportb(adr_tty);timeout++;}
	outportb(adr_tty,x);
	textattr(0x74);
	gotoxy(32,19);
	timeout=0;
	while((ready==0) && (timeout<1000L)){timeout++;delay(1);}
	ready=0;
	y=zeichen;
	cprintf("Teste:  Soll=%2x  ",x);
	cprintf("Ist=%2x ",y);
	if((y!=x) || (timeout>=1000L))
	  {
	    if(timeout>=1000L)
	      {
		erg=3;
		break;
	      }
	    else
	      erg=2;
	    break;
	  }
      }
    }  
    else
      erg=4;
  gotoxy(32,19);
  textattr(0x70);
  cprintf("                        ");


  outportb(adr_tty+1,0);
  outportb(adr_tty+4,7);
  setvect(INTNO,oldint);
  outportb(0x21,oldmask);
  outportb(0x20,0x20);
  return(erg);
}

/************************************************************************/

void install(int baud)
{
  char x;

  outportb(adr_tty+7,0xAC);
  if(inportb(adr_tty+7)==0xAC)
    {
      /* Initialisieren der Schnittstelle */
      outportb(adr_tty+3,0x80);
      switch(baud)
	{
	  case 75:
	    {
	      outportb(adr_tty+1,0x06);
	      outportb(adr_tty  ,0x00);
	      break;
	    }
	  case 300:
	    {
	      outportb(adr_tty+1,0x01);
	      outportb(adr_tty  ,0x80);
	      break;
	    }
	  case 1200:
	    {
	      outportb(adr_tty+1,0x00);
	      outportb(adr_tty  ,0x96);
	      break;
	    }
	  case 2400:
	    {
	      outportb(adr_tty+1,0x00);
	      outportb(adr_tty  ,0x30);
	      break;
	    }
	  case 4800:
	    {
	      outportb(adr_tty+1,0x00);
	      outportb(adr_tty  ,0x18);
	      break;
	    }
	  case 9600:
	    {
	      outportb(adr_tty+1,0x00);
	      outportb(adr_tty  ,0x0C);
	      break;
	    }
	  case 19200:
	    {
	      outportb(adr_tty+1,0x00);
	      outportb(adr_tty  ,0x06);
	      break;
	    }
	}
      outportb(adr_tty+3,0x1f);
      outportb(adr_tty+1,0);
      outportb(adr_tty+4,0x07);
      for(x=0;x<16;x++)
	inportb(adr_tty);
      outportb(adr_tty+2,7);
      delay(10);
      outportb(adr_tty+2,1);
      x=inportb(adr_tty+2);
      if((x & 0xC0)==0)
	uart=1;
      else
	uart=2;
    }
  else
    uart=0;
}

/************************************************************************/
char test_tty(void)
{
  int x,y;
  char erg=1;
  long timeout;

  if(uart!=0)
    for(x=32;x<256;x++)
      {
	timeout=0;
	while(((inportb(adr_tty+5) & 1)!=0) && (timeout<100000L)){inportb(adr_tty);timeout++;}
	outportb(adr_tty,x);
	textattr(0x74);
	gotoxy(32,19);
	timeout=0;
	while(((inportb(adr_tty+5) & 64)==0) && (timeout<100000L))timeout++;
	timeout=0;
	while(((inportb(adr_tty+5) & 1)==0) && timeout<60000L)timeout++;
	y=inportb(adr_tty);
	cprintf("Teste:  Soll=%2x  ",x);
	cprintf("Ist=%2x ",y);
	if((y!=x) || (timeout>=60000L))
	  {
	    if(timeout>=60000L)
	      {
		erg=3;
		break;
	      }
	    else
	      erg=2;
	    break;
	  }
      }
    else
      erg=4;
  gotoxy(32,19);
  textattr(0x70);
  cprintf("                        ");
  return(erg);
}

/************************************************************************/

void interrupt test_routine(void)
{
  if((inportb(adr_tty+5) & 1)== 1)
    {
      zeichen=inportb(adr_tty);
      ready=1;
      outportb(0x20,0x20);
    }
  else
    oldint();
}

/************************************************************************/

void show_status(void)
{
  char x;

  for(x=0;x<7;x++)
    {
      gotoxy(35,x+11);
      switch (test[x][0])
	{
	  case 0 :
	    {
	      textattr(0x7E);
	      cprintf("   ?   ");
	      break;
	    }
	  case 1 :
	    {
	      textattr(0x7E);
	      cprintf(" O.K.  ");
	      break;
	    }
	  case 2 :
	    {
	      textattr(0x74);
	      cprintf("FEHLER ");
	      break;
	    }
	  case 3 :
	    {
	      textattr(0x74);
	      cprintf("TIMEOUT");
	      break;
	    }
	  case 4 :
	    {
	      textattr(0x74);
	      cprintf("NO UART");
	      break;
	    }
	}
    }
  for(x=0;x<7;x++)
    {
      gotoxy(47,x+11);
      switch (test[x][1])
	{
	  case 0 :
	    {
	      textattr(0x7E);
	      cprintf("   ?   ");
	      break;
	    }
	  case 1 :
	    {
	      textattr(0x7E);
	      cprintf(" O.K.  ");
	      break;
	    }
	  case 2 :
	    {
	      textattr(0x74);
	      cprintf("FEHLER ");
	      break;
	    }
	  case 3 :
	    {
	      textattr(0x74);
	      cprintf("TIMEOUT");
	      break;
	    }
	  case 4:
	    {
	      textattr(0x74);
	      cprintf("NO UART");
	      break;
	    }
	}
    }
}

/************************************************************************/

void main_menu(void)
{
  int z;
  char text1[]="ͻ";
  char text2[]="                                                      ";
  char text3[]="ͼ";
  char text4[]="";
 char text50[]="  Betriebsart:  Polling     Interrupt           ";
  char text5[]="  75   Baud  :                                  ";
  char text6[]="  300  Baud  :                                  ";
  char text7[]="  1200 Baud  :                                  ";
  char text8[]="  2400 Baud  :                                  ";
  char text9[]="  4800 Baud  :                                  ";
  char text10[]="  9600 Baud  :                                 ";
  char text11[]="  19,2 KBaud :                                 ";
  char text12[]="         Starten des Tests durch Taste F 1            ";
  char text13[]="       Beenden der Tests durch die Taste F 10         ";

  int x=14;
  int y=8;

  clear_screen();
//  install();

  /* Erzeugen eines Fensters */
  gotoxy(x,y);
  textattr(0x7F);
  cprintf(text1);
  for(z=0;z<13;z++)
	 {
		gotoxy(x,y+z+1);
		cprintf(text2);
	 }

  textattr(0x70);
  gotoxy(x+5,y+1);
  cprintf(text50);
  gotoxy(x+5,y+3);
  cprintf(text5);
  gotoxy(x+5,y+4);
  cprintf(text6);
  gotoxy(x+5,y+5);
  cprintf(text7);
  gotoxy(x+5,y+6);
  cprintf(text8);
  gotoxy(x+5,y+7);
  cprintf(text9);
  gotoxy(x+5,y+8);
  cprintf(text10);
  gotoxy(x+5,y+9);
  cprintf(text11);
  textattr(0x13);
  gotoxy(x+1,y+12);
  cprintf(text12);
  textattr(0x7F);
  gotoxy(x,y+14);
  cprintf(text3);
  textattr(0x70);
  gotoxy(x+1,y+15);
  cprintf(text4);
  for (z=0;z<14;z++)
	 {
		gotoxy(x+56,y+1+z);
		cprintf("");
	 }
  textattr(0x13);
  gotoxy(x+1,y+13);
  cprintf(text13);

}

/************************************************************************
 ***                Unterprogramme zur Bildschirmsteuerung            ***
 ************************************************************************/

void clear_screen(void)
{
  /* Diese Funktion dient zum lschen des Bildschirmes, sowie dessen
     Einstellung. Der Hintergrund wird auf die Farbe Blau eingestellt.
     Es wird des weiteren ein Fenster mit der Firmenadresse dargestellt.  */

  char rahm1[]="ͻ";
  char rahm2[]="                                                         ";
  char rahm3[]="ͼ";
  char text1[]=" ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen";
  char text2[]="      Tel. 07462/7381               Fax 07462/7554       ";
  char text3[]="";

  textbackground(BLUE);                 /* Hintergrundfarbe schwarz     */
  textcolor(CYAN);                      /* Vordergrundfarbe hellgrau    */
  clrscr();                             /* Bildschirm lschen           */

  /* Erzeugen eines Fensters */
  gotoxy(12,2);
  textattr(0x7F);
  cprintf(rahm1);
  gotoxy(12,3);
  cprintf(rahm2);
  gotoxy(12,4);
  cprintf(rahm2);
  gotoxy(12,5);
  cprintf(rahm3);
  /* Erzeugen des Fenstertextes */
  textattr(0x70);
  gotoxy(13,3);
  cprintf(text1);
  gotoxy(13,4);
  cprintf(text2);
  /* Erzeugen des Fensterschattens */
  gotoxy(13,6);
  cprintf(text3);
  gotoxy(71,3);
  cprintf("");
  gotoxy(71,4);
  cprintf("");
  gotoxy(71,5);
  cprintf("");
  textattr(0x03);
}

/***************************************************************************/

void write_position(int x,int y,char *text,int attr)
{
  if (attr==0)
    textattr(0x10);
  if (attr==1)
    textattr(0x3E);
  gotoxy(x,y);
  cprintf(text);

}
