(**********************************************************)
(* TTY1241.PAS ---------15.02.91------------------------- *)
(**********************************************************)

PROGRAM TTY1241;
uses dos,crt;

TYPE    par_typ = (N,E,O);

VAR    adresse,p     : string;
       baud , channel: integer;
       wordlen       : integer;
       stopbit       : integer;
       CODE          : integer;
       parity        : par_typ;
       Fehler        : boolean;

procedure mode(channel,baud:integer;parity:par_typ;wordlen,stopbit:integer);

var       DLL,DLM,IER,LCR,DGC,LCD : integer;

begin (* procedure mode *)
      DLL:=channel;
      DLM:=channel+1;
      IER:=channel+1;
      LCR:=channel+3;

      case baud of
           300 : DGC:= $180;
           600 : DGC:= $0C0;
          1200 : DGC:= $060;
          2400 : DGC:= $030;
      end;

      case wordlen of
           5 : LCD:= 0;
           6 : LCD:= 1;
           7 : LCD:= 2;
           8 : LCD:= 3;
      end;

      case stopbit of
           1 :;
           2 : LCD:=LCD+4;
      end;

      case parity of
           N :;
           E : LCD:=LCD+24;
           O : LCD:=LCD+8;
      end;

      port[LCR] := $80;
      port[DLM] := Hi(DGC);
      port[DLL] := Lo(DGC);
      port[LCR] := LCD;
      port[IER] := $00;

end; (* procedure mode *)

procedure test(baud : integer);
var       i : byte;
          z : byte;
          timeout : integer;
begin
          for i:=1 to 9 do begin
              port[channel]:=i;
              timeout:=0;
              repeat
              timeout:=timeout+1;
              until (((port[channel] and $01)=$01) or (timeout>11000));
              case baud of
                   600 : delay(10);
                   300 : delay(35);
              end;
              delay(10);
              z:=port[channel];
              if (i<>z) or (timeout>11000) then Fehler:=TRUE;
          end;
end; (* procedure test*)

BEGIN (* HAUPTPROGRAMM *)
      clrscr;
      writeln('*** PROGRAMM   TTY 1241 ***');
      writeln('');
      writeln('> Schnittstellen - Initialisierung <');
      writeln('');writeln('');
      write('BAUDRATE ?  ( 300 ; 600 ; 1200 oder 2400 )  ');
      readln(baud);writeln('');
      write('WORTLNGE ?  ( 5 ; 6 ; 7 oder 8 )  ');
      readln(wordlen);writeln('');
      write('STOPBIT ?  ( 1 oder 2 )  ');
      readln(stopbit);writeln('');
      write('PARITY ?  ( N ; E oder O )  ');
      readln(p);writeln('');
      writeln('ADRESSEINSTELLUNG ?  ( gem Einstellung am Adreschalter');
      write('  !! in HEX - Form !!          der Karte)  ');
      readln(adresse);
      adresse:='$'+adresse;
      Val(adresse,channel,CODE);
      if (p='N')or(p='n') then parity:=N
      else if (p='E')or(p='e') then parity:=E
      else parity:=O;
      mode (channel,baud,parity,wordlen,stopbit);
      Fehler:=FALSE;
      test(baud);
      clrscr;
      if Fehler=FALSE then
         writeln('Schnittstelleninitialisierung abgeschlossen !')
      else
          writeln('Fehler bei Schnittstelleninitialisierung');
END. (* HAUPTPROGRAMM *)

