Attribute VB_Name = "Module2"
Rem ************************************************
Rem *** Diese Funktionen stellen die             ***
Rem *** Hardwarefunktionen ber den Treiber      ***
Rem *** ErmaUni und seiner DLL zur Verfgung     ***
Rem ************************************************

Rem ************************************************
Rem *** Zhlermodi                               ***
Rem ************************************************
Rem *** HINWEIS: Die aufteilung in 2 16Bit-Zhler***
Rem *** ist bei der ZIB1155 und ZIB1155/OPTO     ***
Rem *** nicht mglich!                           ***
Rem ************************************************
Public Const VierfachZaehlungA = &H0
Public Const ZweifachZaehlungA = &H1
Public Const EinfachZaehlungA = &H4
Public Const VierfachZaehlungB = &H0
Public Const ZweifachZaehlungB = &H2
Public Const EinfachZaehlungB = &H8
Rem *** Zhler A und B bilden einen 32Bit-Zhler ***
Public Const Einmal_32Bit = &H0
Rem *** Zhler A und B liden getrennte 16 Bit-Zhler ***
Public Const Zweimal_16Bit = &H10
Rem *** Unterdrckung des ersten Impulses bei Drehrichtungsumkehr ***
Rem *** nicht bei Ereigniszhlung! ***
Public Const HystereseA = &H20
Rem *** Aufwrts- und Abwrtszhlung nur bei Ereigniszhlung! ***
Public Const ZaehlerAaufwaerts = &H0
Public Const ZaehlerAabwaerts = &H20
Rem *** Unterdrckung des ersten Impulses bei Drehrichtungsumkehr ***
Rem *** nicht bei Ereigniszhlung ***
Public Const HystereseB = &H40
Rem *** Aufwrts- und Abwrtszhlung nur bei Ereigniszhlung! ***
Public Const ZaehlerBaufwaerts = &H0
Public Const ZaehlerBabwaerts = &H40
Rem *** Umschalten auf Ereigniszhlung ***
Public Const EreignisZaehlung = &H80

Rem ************************************************
Rem *** Einbinden der DLL-Funktionen             ***
Rem ************************************************
Public Declare Sub InitDriver Lib "ermauni" Alias "_ErmaUniInitDriver@0" ()
Public Declare Sub DeInitDriver Lib "ermauni" Alias "_ErmaUniDeInitDriver@0" ()
Private Declare Function ReadBytePort Lib "ermauni.dll" Alias "_ErmaUniReadByte@4" (ByVal PortAdr As Long) As Byte
Private Declare Sub WriteBytePort Lib "ermauni" Alias "_ErmaUniWriteByte@8" (ByVal PortAdr As Long, ByVal Value As Byte)

Rem ************************************************
Rem *** Definition der Ports                     ***
Rem ************************************************
Private Const PortLow = &H6
Private Const PortHigh = &H7
Private Const ConfigZaehler1 = &H5
Private Const ConfigZaehler2 = &HD
Private Const ConfigZaehler3 = &H15
Private Const ConfigZaehler4 = &H1D
Private Const StatusZaehler1 = &H0
Private Const StatusZaehler2 = &H8
Private Const StatusZaehler3 = &H10
Private Const StatusZaehler4 = &H18
Private Const BasisZaehler1 = &H1
Private Const BasisZaehler2 = &H9
Private Const BasisZaehler3 = &H11
Private Const BasisZaehler4 = &H19

Rem ************************************************
Rem *** Diese Funktion setzt den Mode eines      ***
Rem *** Zaehlers                                 ***
Rem ************************************************

Sub SetZaehlerMode(ZaehlerNr As Integer, ZaehlerMode As Byte)
  Select Case ZaehlerNr
  Case 1
    Rem *** Mode Zaehler 1 setzen ***
    Call WriteBytePort(ConfigZaehler1, ZaehlerMode)
  Case 2
    Rem *** Mode Zaehler 2 setzen ***
    Call WriteBytePort(ConfigZaehler2, ZaehlerMode)
  Case 3
    Rem *** Mode Zaehler 3 setzen ***
    Call WriteBytePort(ConfigZaehler3, ZaehlerMode)
  Case 4
    Rem *** Mode Zaehler 4 setzen ***
    Call WriteBytePort(ConfigZaehler4, ZaehlerMode)
  End Select
  Call ResetZaehler(ZaehlerNr)
End Sub

Rem ************************************************
Rem *** Diese Funktion setzt einen Zhler zurck ***
Rem ************************************************

Sub ResetZaehler(ZaehlerNr As Integer)
  Select Case ZaehlerNr
  Case 1
    Rem *** Zaehler 1 rcksetzen ***
    Call WriteBytePort(BasisZaehler1, 0)
    Call WriteBytePort(BasisZaehler1 + 1, 0)
    Call WriteBytePort(BasisZaehler1 + 2, 0)
    Call WriteBytePort(BasisZaehler1 + 3, 0)
  Case 2
    Rem *** Zaehler 2 rcksetzen ***
    Call WriteBytePort(BasisZaehler2, 0)
    Call WriteBytePort(BasisZaehler2 + 1, 0)
    Call WriteBytePort(BasisZaehler2 + 2, 0)
    Call WriteBytePort(BasisZaehler2 + 3, 0)
  Case 3
    Rem *** Zaehler 3 rcksetzen ***
    Call WriteBytePort(BasisZaehler3, 0)
    Call WriteBytePort(BasisZaehler3 + 1, 0)
    Call WriteBytePort(BasisZaehler3 + 2, 0)
    Call WriteBytePort(BasisZaehler3 + 3, 0)
  Case 4
    Rem *** Zaehler 4 rcksetzen ***
    Call WriteBytePort(BasisZaehler4, 0)
    Call WriteBytePort(BasisZaehler4 + 1, 0)
    Call WriteBytePort(BasisZaehler4 + 2, 0)
    Call WriteBytePort(BasisZaehler4 + 3, 0)
  End Select
End Sub

Rem ************************************************
Rem *** Diese Funktion setzt alle Zhler zurck  ***
Rem ************************************************

Sub ResetZaehler1_4()
  ResetZaehler (1)
  ResetZaehler (2)
  ResetZaehler (3)
  ResetZaehler (4)
End Sub

Rem ************************************************
Rem *** Diese Funktion liest einen Zhler aus    ***
Rem ************************************************

Function GetZaehler(ZaehlerNr As Integer) As Long
  Dim B1, B2, B3, B4 As Byte
  Dim vorz As Integer
  Select Case ZaehlerNr
  Case 1
    Rem *** Zaehler 1 latchen ***
    Call WriteBytePort(StatusZaehler1, 0)
    Rem *** 1.Byte holen ***
    B1 = ReadBytePort(BasisZaehler1)
    Rem *** 2.Byte holen ***
    B2 = ReadBytePort(BasisZaehler1 + 1)
    Rem *** 3.Byte holen ***
    B3 = ReadBytePort(BasisZaehler1 + 2)
    Rem *** 4.Byte holen ***
    B4 = ReadBytePort(BasisZaehler1 + 3)
  Case 2
    Rem *** Zaehler 2 latchen ***
    Call WriteBytePort(StatusZaehler2, 0)
    Rem *** 1.Byte holen ***
    B1 = ReadBytePort(BasisZaehler2)
    Rem *** 2.Byte holen ***
    B2 = ReadBytePort(BasisZaehler2 + 1)
    Rem *** 3.Byte holen ***
    B3 = ReadBytePort(BasisZaehler2 + 2)
    Rem *** 4.Byte holen ***
    B4 = ReadBytePort(BasisZaehler2 + 3)
  Case 3
    Rem *** Zaehler 3 latchen ***
    Call WriteBytePort(StatusZaehler3, 0)
    Rem *** 1.Byte holen ***
    B1 = ReadBytePort(BasisZaehler3)
    Rem *** 2.Byte holen ***
    B2 = ReadBytePort(BasisZaehler3 + 1)
    Rem *** 3.Byte holen ***
    B3 = ReadBytePort(BasisZaehler3 + 2)
    Rem *** 4.Byte holen ***
    B4 = ReadBytePort(BasisZaehler3 + 3)
  Case 4
    Rem *** Zaehler 4 latchen ***
    Call WriteBytePort(StatusZaehler4, 0)
    Rem *** 1.Byte holen ***
    B1 = ReadBytePort(BasisZaehler4)
    Rem *** 2.Byte holen ***
    B2 = ReadBytePort(BasisZaehler4 + 1)
    Rem *** 3.Byte holen ***
    B3 = ReadBytePort(BasisZaehler4 + 2)
    Rem *** 4.Byte holen ***
    B4 = ReadBytePort(BasisZaehler4 + 3)
  Case Else
    Rem *** Wert 0 zurckgeben ***
    B1 = 0
    B2 = 0
    B3 = 0
    B4 = 0
  End Select
  Rem *** Ergebnis erzeugen ***
  If B4 > 127 Then
    vorz = -1
    B4 = B4 And &H7F
    Rem *** negatives Ergebnis ist Komplement ***
    B4 = B4 Xor &H7F
    B3 = B3 Xor &HFF
    B2 = B2 Xor &HFF
    B1 = B1 Xor &HFF
  Else
    vorz = 1
  End If
  GetZaehler = (B4 * (2 ^ 24) Or B3 * (2 ^ 16) Or B2 * (2 ^ 8) Or B1) * vorz
  If vorz = -1 Then GetZaehler = GetZaehler - 1
End Function

Rem ************************************************
Rem *** Diese Funktion liest einen Eingangsport  ***
Rem *** ein.                                     ***
Rem ************************************************

Function GetPort(PortNr As Integer) As Integer
  Rem *** Port auslesen ***
  Select Case PortNr
  Case 1
    GetPort = &HFF Xor ReadBytePort(PortLow)
  Case 2
    GetPort = &HFF Xor ReadBytePort(PortHigh)
  Case Else
    GetPort = 0
  End Select
End Function

Rem ************************************************
Rem *** Diese Funktion setzt einen Ausgangsport  ***
Rem ************************************************

Sub SetPort(PortNr As Integer, Wert As Byte)
  Rem *** Port setzen ***
  Select Case PortNr
  Case 1
    Call WriteBytePort(PortLow, Wert)
  Case 2
    Call WriteBytePort(PortHigh, Wert)
  End Select
End Sub
